Index: squid/src/fs/diskd/store_dir_diskd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/diskd/store_dir_diskd.c,v
retrieving revision 1.1.6.1
retrieving revision 1.1.6.2
diff -u -r1.1.6.1 -r1.1.6.2
--- squid/src/fs/diskd/store_dir_diskd.c	2 May 2000 22:50:29 -0000	1.1.6.1
+++ squid/src/fs/diskd/store_dir_diskd.c	14 May 2000 23:22:20 -0000	1.1.6.2
@@ -81,7 +81,7 @@
 
 static int n_diskd_dirs = 0;
 static int *diskd_dir_index = NULL;
-MemPool * diskd_state_pool = NULL;
+MemPool *diskd_state_pool = NULL;
 static int diskd_initialised = 0;
 
 static char *storeDiskdDirSwapSubDir(SwapDir *, int subdirn);
@@ -93,7 +93,7 @@
 static EVH storeDiskdDirRebuildFromDirectory;
 static EVH storeDiskdDirRebuildFromSwapLog;
 static int storeDiskdDirGetNextFile(RebuildState *, int *sfileno, int *size);
-static StoreEntry *storeDiskdDirAddDiskRestore(SwapDir *SD, const cache_key * key,
+static StoreEntry *storeDiskdDirAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -109,9 +109,10 @@
 static STLOGOPEN storeDiskdDirOpenSwapLog;
 static STINIT storeDiskdDirInit;
 static STFREE storeDiskdDirFree;
-static STLOGCLEANOPEN storeDiskdDirWriteCleanOpen;
-static void storeDiskdDirWriteCleanClose(SwapDir * sd);
+static STLOGCLEANSTART storeDiskdDirWriteCleanStart;
+static STLOGCLEANNEXTENTRY storeDiskdDirCleanLogNextEntry;
 static STLOGCLEANWRITE storeDiskdDirWriteCleanEntry;
+static STLOGCLEANDONE storeDiskdDirWriteCleanDone;
 static STLOGCLOSE storeDiskdDirCloseSwapLog;
 static STLOGWRITE storeDiskdDirSwapLog;
 static STNEWFS storeDiskdDirNewfs;
@@ -129,13 +130,8 @@
 static void storeDiskdDirStats(SwapDir *, StoreEntry *);
 static void storeDiskdDirInitBitmap(SwapDir *);
 static int storeDiskdDirValidFileno(SwapDir *, sfileno);
-static int storeDiskdDirCheckExpired(SwapDir *, StoreEntry *);
-#if !HEAP_REPLACEMENT
-static time_t storeDiskdDirExpiredReferenceAge(SwapDir *);
-#endif
 static void storeDiskdStats(StoreEntry * sentry);
 static void storeDiskdDirSync(SwapDir *);
-static void storeDiskdDirCallback(SwapDir *);
 
 
 /*
@@ -146,43 +142,43 @@
  */
 
 int
-storeDiskdDirMapBitTest(SwapDir *SD, int fn)
+storeDiskdDirMapBitTest(SwapDir * SD, int fn)
 {
     sfileno filn = fn;
     diskdinfo_t *diskdinfo;
-    diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo = (diskdinfo_t *) SD->fsdata;
     return file_map_bit_test(diskdinfo->map, filn);
 }
- 
+
 void
-storeDiskdDirMapBitSet(SwapDir *SD, int fn)
-{  
+storeDiskdDirMapBitSet(SwapDir * SD, int fn)
+{
     sfileno filn = fn;
     diskdinfo_t *diskdinfo;
-    diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo = (diskdinfo_t *) SD->fsdata;
     file_map_bit_set(diskdinfo->map, filn);
 }
- 
+
 void
-storeDiskdDirMapBitReset(SwapDir *SD, int fn)
-{ 
+storeDiskdDirMapBitReset(SwapDir * SD, int fn)
+{
     sfileno filn = fn;
     diskdinfo_t *diskdinfo;
-    diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo = (diskdinfo_t *) SD->fsdata;
     file_map_bit_reset(diskdinfo->map, filn);
 }
 
 int
-storeDiskdDirMapBitAllocate(SwapDir *SD)
+storeDiskdDirMapBitAllocate(SwapDir * SD)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
     int fn;
     fn = file_map_allocate(diskdinfo->map, diskdinfo->suggest);
     file_map_bit_set(diskdinfo->map, fn);
     diskdinfo->suggest = fn + 1;
     return fn;
 }
-    
+
 /*
  * Initialise the diskd bitmap
  *
@@ -190,16 +186,16 @@
  * configured, we allocate a new bitmap and 'grow' the old one into it.
  */
 static void
-storeDiskdDirInitBitmap(SwapDir *sd)
+storeDiskdDirInitBitmap(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
 
     if (diskdinfo->map == NULL) {
-        /* First time */
+	/* First time */
 	diskdinfo->map = file_map_create();
     } else if (diskdinfo->map->max_n_files) {
-        /* it grew, need to expand */
-        /* XXX We don't need it anymore .. */
+	/* it grew, need to expand */
+	/* XXX We don't need it anymore .. */
     }
     /* else it shrunk, and we leave the old one in place */
 }
@@ -207,7 +203,7 @@
 static char *
 storeDiskdDirSwapSubDir(SwapDir * sd, int subdirn)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
 
     LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
     assert(0 <= subdirn && subdirn < diskdinfo->l1);
@@ -260,7 +256,7 @@
 static int
 storeDiskdDirVerifyCacheDirs(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     int j;
     const char *path = sd->path;
 
@@ -277,7 +273,7 @@
 static void
 storeDiskdDirCreateSwapSubDirs(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     int i, k;
     int should_exist;
     LOCAL_ARRAY(char, name, MAXPATHLEN);
@@ -303,31 +299,31 @@
     LOCAL_ARRAY(char, digit, 32);
     char *pathtmp2;
     if (Config.Log.swap) {
-        xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
-        while (index(pathtmp,'/'))
-            *index(pathtmp,'/')='.';
-        while (strlen(pathtmp) && pathtmp[strlen(pathtmp)-1]=='.')
-            pathtmp[strlen(pathtmp)-1]= '\0';
-        for(pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
-        snprintf(path, SQUID_MAXPATHLEN-64, Config.Log.swap, pathtmp2);
-        if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
-            strcat(path, ".");
-            snprintf(digit, 32, "%02d", sd->index);
-            strncat(path, digit, 3);
-        }
+	xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
+	while (index(pathtmp, '/'))
+	    *index(pathtmp, '/') = '.';
+	while (strlen(pathtmp) && pathtmp[strlen(pathtmp) - 1] == '.')
+	    pathtmp[strlen(pathtmp) - 1] = '\0';
+	for (pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+	snprintf(path, SQUID_MAXPATHLEN - 64, Config.Log.swap, pathtmp2);
+	if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
+	    strcat(path, ".");
+	    snprintf(digit, 32, "%02d", sd->index);
+	    strncat(path, digit, 3);
+	}
     } else {
-        xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
-        strcat(path, "/swap.state");
+	xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
+	strcat(path, "/swap.state");
     }
     if (ext)
-        strncat(path, ext, 16);
+	strncat(path, ext, 16);
     return path;
 }
 
 static void
 storeDiskdDirOpenSwapLog(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     char *path;
     int fd;
     path = storeDiskdDirSwapLogFile(sd, NULL);
@@ -347,7 +343,7 @@
 static void
 storeDiskdDirCloseSwapLog(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     if (diskdinfo->swaplog_fd < 0)	/* not open */
 	return;
     file_close(diskdinfo->swaplog_fd);
@@ -380,28 +376,28 @@
 
     diskdinfo->smsgid = msgget((key_t) ikey, 0700 | IPC_CREAT);
     if (diskdinfo->smsgid < 0) {
-        debug(50, 0) ("storeDiskdInit: msgget: %s\n", xstrerror());
-        fatal("msgget failed");
+	debug(50, 0) ("storeDiskdInit: msgget: %s\n", xstrerror());
+	fatal("msgget failed");
     }
     diskdinfo->rmsgid = msgget((key_t) (ikey + 1), 0700 | IPC_CREAT);
     if (diskdinfo->rmsgid < 0) {
-        debug(50, 0) ("storeDiskdInit: msgget: %s\n", xstrerror());
-        fatal("msgget failed");
+	debug(50, 0) ("storeDiskdInit: msgget: %s\n", xstrerror());
+	fatal("msgget failed");
     }
     diskdinfo->shm.id = shmget((key_t) (ikey + 2),
-        SHMBUFS * SHMBUF_BLKSZ, 0600 | IPC_CREAT);
+	SHMBUFS * SHMBUF_BLKSZ, 0600 | IPC_CREAT);
     if (diskdinfo->shm.id < 0) {
-        debug(50, 0) ("storeDiskdInit: shmget: %s\n", xstrerror());
-        fatal("shmget failed");
+	debug(50, 0) ("storeDiskdInit: shmget: %s\n", xstrerror());
+	fatal("shmget failed");
     }
     diskdinfo->shm.buf = shmat(diskdinfo->shm.id, NULL, 0);
     if (diskdinfo->shm.buf == (void *) -1) {
-        debug(50, 0) ("storeDiskdInit: shmat: %s\n", xstrerror());
-        fatal("shmat failed");
+	debug(50, 0) ("storeDiskdInit: shmat: %s\n", xstrerror());
+	fatal("shmat failed");
     }
     diskd_stats.shmbuf_count += SHMBUFS;
     for (i = 0; i < SHMBUFS; i++)
-        storeDiskdShmPut(sd, i * SHMBUF_BLKSZ);
+	storeDiskdShmPut(sd, i * SHMBUF_BLKSZ);
     snprintf(skey1, 32, "%d", ikey);
     snprintf(skey2, 32, "%d", ikey + 1);
     snprintf(skey3, 32, "%d", ikey + 2);
@@ -416,15 +412,15 @@
 #else
     x = ipcCreate(IPC_FIFO,
 #endif
-        SQUID_PREFIX "/bin/diskd",
-        args,
-        "diskd",
-        &rfd,
-        &diskdinfo->wfd);
+	SQUID_PREFIX "/bin/diskd",
+	args,
+	"diskd",
+	&rfd,
+	&diskdinfo->wfd);
     if (x < 0)
-        fatal("execl " SQUID_PREFIX "/bin/diskd failed");
+	fatal("execl " SQUID_PREFIX "/bin/diskd failed");
     if (rfd != diskdinfo->wfd)
-        comm_close(rfd);
+	comm_close(rfd);
     fd_note(diskdinfo->wfd, "squid -> diskd");
     commSetTimeout(diskdinfo->wfd, -1, NULL, NULL);
     commSetNonBlocking(diskdinfo->wfd);
@@ -459,7 +455,7 @@
  * until the data has finished writing.
  */
 static void
-storeDiskdDirSync(SwapDir *SD)
+storeDiskdDirSync(SwapDir * SD)
 {
     /* XXX NOT DONE YET! */
 #warning "storeDiskdSync() needs to be written"
@@ -473,35 +469,34 @@
  * until the queue is below magic2. Otherwise, we simply return when we
  * don't get a message.
  */
-static void
-storeDiskdDirCallback(SwapDir *SD)
+void
+storeDiskdDirCallback(SwapDir * SD)
 {
     diomsg M;
     int x;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
 
     if (diskdinfo->away >= diskdinfo->magic2)
 	diskd_stats.block_queue_len++;
 
     if (diskd_stats.sent_count - diskd_stats.recv_count >
-      diskd_stats.max_away) {
-        diskd_stats.max_away = diskd_stats.sent_count - diskd_stats.recv_count;
-        diskd_stats.max_shmuse = diskd_stats.shmbuf_count;
+	diskd_stats.max_away) {
+	diskd_stats.max_away = diskd_stats.sent_count - diskd_stats.recv_count;
+	diskd_stats.max_shmuse = diskd_stats.shmbuf_count;
     }
-
     /* if we are above magic2, we do not break under any reason */
     while (1) {
-        memset(&M, '\0', sizeof(M));
-        x = msgrcv(diskdinfo->rmsgid, &M, msg_snd_rcv_sz, 0, IPC_NOWAIT);
+	memset(&M, '\0', sizeof(M));
+	x = msgrcv(diskdinfo->rmsgid, &M, msg_snd_rcv_sz, 0, IPC_NOWAIT);
 	if (x < 0) {
 	    if (diskdinfo->away >= diskdinfo->magic2)
 		continue;
-            else
-                break;
+	    else
+		break;
 	} else if (x != msg_snd_rcv_sz) {
-            debug(81, 1) ("storeDiskdReadIndividualQueue: msgget returns %d\n",
-	      x);
-            break;
+	    debug(81, 1) ("storeDiskdDirCallback: msgget returns %d\n",
+		x);
+	    break;
 	}
 	diskd_stats.recv_count++;
 	diskdinfo->away--;
@@ -580,7 +575,7 @@
 	tlv_list = storeSwapMetaUnpack(hdr_buf, &swap_hdr_len);
 	if (tlv_list == NULL) {
 	    debug(20, 1) ("storeDiskdDirRebuildFromDirectory: failed to get meta data\n");
-            /* XXX shouldn't this be a call to storeDiskdUnlink ? */
+	    /* XXX shouldn't this be a call to storeDiskdUnlink ? */
 	    storeDiskdDirUnlinkFile(SD, sfileno);
 	    continue;
 	}
@@ -700,13 +695,13 @@
 		 * because adding to store_swap_size happens in
 		 * the cleanup procedure.
 		 */
-                storeExpireNow(e);
-                storeReleaseRequest(e);
-                storeDiskdDirReplRemove(e);
+		storeExpireNow(e);
+		storeReleaseRequest(e);
+		storeDiskdDirReplRemove(e);
 		if (e->swap_filen > -1) {
 		    storeDiskdDirMapBitReset(SD, e->swap_filen);
 		    e->swap_filen = -1;
-                    e->swap_dirn = -1;
+		    e->swap_dirn = -1;
 		}
 		storeRelease(e);
 		rb->counts.objcount--;
@@ -751,10 +746,7 @@
 		e->lastmod = s.lastmod;
 		e->flags = s.flags;
 		e->refcount += s.refcount;
-#if HEAP_REPLACEMENT
-		storeHeapPositionUpdate(e, SD);
-                storeDiskdDirUnrefObj(SD, e);
-#endif
+		storeDiskdDirUnrefObj(SD, e);
 	    } else {
 		debug_trap("storeDiskdDirRebuildFromSwapLog: bad condition");
 		debug(20, 1) ("\tSee %s:%d\n", __FILE__, __LINE__);
@@ -788,14 +780,14 @@
 	} else if (e) {
 	    /* key already exists, this swapfile not being used */
 	    /* junk old, load new */
-            storeExpireNow(e);
-            storeReleaseRequest(e);
-            storeDiskdDirReplRemove(e);
+	    storeExpireNow(e);
+	    storeReleaseRequest(e);
+	    storeDiskdDirReplRemove(e);
 	    if (e->swap_filen > -1) {
-                /* Make sure we don't actually unlink the file */
+		/* Make sure we don't actually unlink the file */
 		storeDiskdDirMapBitReset(SD, e->swap_filen);
 		e->swap_filen = -1;
-                e->swap_dirn = -1;
+		e->swap_dirn = -1;
 	    }
 	    storeRelease(e);
 	    rb->counts.dupcount++;
@@ -825,7 +817,7 @@
 storeDiskdDirGetNextFile(RebuildState * rb, int *sfileno, int *size)
 {
     SwapDir *SD = rb->sd;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
     int fd = -1;
     int used = 0;
     int dirs_opened = 0;
@@ -911,7 +903,7 @@
 /* Add a new object to the cache with empty memory copy and pointer to disk
  * use to rebuild store from disk. */
 static StoreEntry *
-storeDiskdDirAddDiskRestore(SwapDir *SD, const cache_key * key,
+storeDiskdDirAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -934,9 +926,6 @@
     e->swap_dirn = SD->index;
     e->swap_file_sz = swap_file_sz;
     e->lock_count = 0;
-#if !HEAP_REPLACEMENT
-    e->refcount = 0;
-#endif
     e->lastref = lastref;
     e->timestamp = timestamp;
     e->expires = expires;
@@ -992,7 +981,7 @@
 static void
 storeDiskdDirCloseTmpSwapLog(SwapDir * sd)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     char *swaplog_path = xstrdup(storeDiskdDirSwapLogFile(sd, NULL));
     char *new_path = xstrdup(storeDiskdDirSwapLogFile(sd, ".new"));
     int fd;
@@ -1020,7 +1009,7 @@
 static FILE *
 storeDiskdDirOpenTmpSwapLog(SwapDir * sd, int *clean_flag, int *zero_flag)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     char *swaplog_path = xstrdup(storeDiskdDirSwapLogFile(sd, NULL));
     char *clean_path = xstrdup(storeDiskdDirSwapLogFile(sd, ".last-clean"));
     char *new_path = xstrdup(storeDiskdDirSwapLogFile(sd, ".new"));
@@ -1073,6 +1062,7 @@
     char *outbuf;
     off_t outbuf_offset;
     int fd;
+    RemovalPolicyWalker *walker;
 };
 
 #define CLEAN_BUF_SZ 16384
@@ -1082,7 +1072,7 @@
  * we succeed, and assign the 'func' and 'data' return pointers.
  */
 static int
-storeDiskdDirWriteCleanOpen(SwapDir * sd)
+storeDiskdDirWriteCleanStart(SwapDir * sd)
 {
     struct _clean_state *state = xcalloc(1, sizeof(*state));
     struct stat sb;
@@ -1093,6 +1083,7 @@
     state->cln = xstrdup(storeDiskdDirSwapLogFile(sd, ".last-clean"));
     state->outbuf = xcalloc(CLEAN_BUF_SZ, 1);
     state->outbuf_offset = 0;
+    state->walker = sd->repl->WalkInit(sd->repl);
     unlink(state->new);
     unlink(state->cln);
     state->fd = file_open(state->new, O_WRONLY | O_CREAT | O_TRUNC);
@@ -1110,18 +1101,27 @@
 }
 
 /*
+ * Get the next entry that is a candidate for clean log writing
+ */
+const StoreEntry *
+storeDiskdDirCleanLogNextEntry(SwapDir * sd)
+{
+    const StoreEntry *entry = NULL;
+    struct _clean_state *state = sd->log.clean.state;
+    if (state->walker)
+	entry = state->walker->Next(state->walker);
+    return entry;
+}
+
+/*
  * "write" an entry to the clean log file.
  */
 static void
-storeDiskdDirWriteCleanEntry(const StoreEntry * e, SwapDir * sd)
+storeDiskdDirWriteCleanEntry(SwapDir *sd, const StoreEntry * e)
 {
     storeSwapLogData s;
     static size_t ss = sizeof(storeSwapLogData);
     struct _clean_state *state = sd->log.clean.state;
-    if (NULL == e) {
-	storeDiskdDirWriteCleanClose(sd);
-	return;
-    }
     memset(&s, '\0', ss);
     s.op = (char) SWAP_LOG_ADD;
     s.swap_filen = e->swap_filen;
@@ -1153,11 +1153,12 @@
 }
 
 static void
-storeDiskdDirWriteCleanClose(SwapDir * sd)
+storeDiskdDirWriteCleanDone(SwapDir * sd)
 {
     struct _clean_state *state = sd->log.clean.state;
     if (state->fd < 0)
 	return;
+    state->walker->Done(state->walker);
     if (write(state->fd, state->outbuf, state->outbuf_offset) < 0) {
 	debug(50, 0) ("storeDirWriteCleanLogs: %s: write: %s\n",
 	    state->new, xstrerror());
@@ -1206,7 +1207,7 @@
 static void
 storeDiskdDirSwapLog(const SwapDir * sd, const StoreEntry * e, int op)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     storeSwapLogData *s = xcalloc(1, sizeof(storeSwapLogData));
     s->op = (char) op;
     s->swap_filen = e->swap_filen;
@@ -1265,7 +1266,7 @@
     N0 = n_diskd_dirs;
     D0 = diskd_dir_index[swap_index % N0];
     SD = &Config.cacheSwap.swapDirs[D0];
-    diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo = (diskdinfo_t *) SD->fsdata;
     N1 = diskdinfo->l1;
     D1 = (swap_index / N0) % N1;
     N2 = diskdinfo->l2;
@@ -1287,7 +1288,7 @@
     while ((de = readdir(dp)) != NULL && k < 20) {
 	if (sscanf(de->d_name, "%X", &swapfileno) != 1)
 	    continue;
-	fn = swapfileno; /* XXX should remove this cruft ! */
+	fn = swapfileno;	/* XXX should remove this cruft ! */
 	if (storeDiskdDirValidFileno(SD, fn))
 	    if (storeDiskdDirMapBitTest(SD, fn))
 		if (storeDiskdFilenoBelongsHere(fn, D0, D1, D2))
@@ -1333,7 +1334,7 @@
     assert(n_diskd_dirs);
     if (NULL == diskd_dir_index) {
 	SwapDir *sd;
-        diskdinfo_t *diskdinfo;
+	diskdinfo_t *diskdinfo;
 	/*
 	 * Initialize the little array that translates DISKD cache_dir
 	 * number into the Config.cacheSwap.swapDirs array index.
@@ -1344,7 +1345,7 @@
 	    if (!storeDiskdDirIs(sd))
 		continue;
 	    diskd_dir_index[n++] = i;
-            diskdinfo = (diskdinfo_t *)sd->fsdata;
+	    diskdinfo = (diskdinfo_t *) sd->fsdata;
 	    j += (diskdinfo->l1 * diskdinfo->l2);
 	}
 	assert(n == n_diskd_dirs);
@@ -1383,7 +1384,7 @@
     int filn = fn;
     diskdinfo_t *diskdinfo;
     assert(F0 < Config.cacheSwap.n_configured);
-    diskdinfo = (diskdinfo_t *)Config.cacheSwap.swapDirs[F0].fsdata;
+    diskdinfo = (diskdinfo_t *) Config.cacheSwap.swapDirs[F0].fsdata;
     L1 = diskdinfo->l1;
     L2 = diskdinfo->l2;
     D1 = ((filn / L2) / L2) % L1;
@@ -1395,167 +1396,60 @@
     return 1;
 }
 
-int 
-storeDiskdDirValidFileno(SwapDir *SD, sfileno filn)
+int
+storeDiskdDirValidFileno(SwapDir * SD, sfileno filn)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
     if (filn < 0)
-        return 0;
-    if (filn > diskdinfo->map->max_n_files)  
-        return 0;
+	return 0;
+    if (filn > diskdinfo->map->max_n_files)
+	return 0;
     return 1;
 }
 
 void
-storeDiskdDirMaintain(SwapDir *SD)
+storeDiskdDirMaintain(SwapDir * SD)
 {
     StoreEntry *e = NULL;
-    int scanned = 0;
-    int locked = 0;
-    int expired = 0;
+    int removed = 0;
     int max_scan;
     int max_remove;
     double f;
-    static time_t last_warn_time = 0;
-#if !HEAP_REPLACEMENT
-    dlink_node *m;
-    dlink_node *prev = NULL;
-#else
-    heap_key age;
-    heap_key min_age = 0.0;
-    link_list *locked_entries = NULL;
-#if HEAP_REPLACEMENT_DEBUG
-    if (!verify_heap_property(SD->repl.heap.heap)) {
-        debug(20, 1) ("Heap property violated!\n");
-    }
-#endif
-#endif
+    RemovalPurgeWalker *walker;
     /* We can't delete objects while rebuilding swap */
     if (store_dirs_rebuilding) {
-        return;
+	return;
     } else {
-        f = (double) (store_swap_size - store_swap_low) / (store_swap_high - store_swap_low);
-        f = f < 0.0 ? 0.0 : f > 1.0 ? 1.0 : f;
-        max_scan = (int) (f * 400.0 + 100.0);
-        max_remove = (int) (f * 70.0 + 10.0);
+	/* XXX FixMe: This should use the cache_dir hig/low values, not the
+	 * global ones
+	 */
+	f = (double) (store_swap_size - store_swap_low) / (store_swap_high - store_swap_low);
+	f = f < 0.0 ? 0.0 : f > 1.0 ? 1.0 : f;
+	max_scan = (int) (f * 400.0 + 100.0);
+	max_remove = (int) (f * 70.0 + 10.0);
 	/*
 	 * This is kinda cheap, but so we need this priority hack?
-         */
-#if 0
-        eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 1.0 - f, 1);
-#endif
+	 */
     }
     debug(20, 3) ("storeMaintainSwapSpace: f=%f, max_scan=%d, max_remove=%d\n", f, max_scan, max_remove);
-#if HEAP_REPLACEMENT
-    while (heap_nodes(SD->repl.heap.heap) > 0) {
-        if (store_swap_size < store_swap_low)
-            break;
-        if (expired >= max_remove)
-            break;
-        if (scanned >= max_scan)
-            break;
-        age = heap_peepminkey(SD->repl.heap.heap);
-        e = heap_extractmin(SD->repl.heap.heap);
-        e->repl.node = NULL;         /* no longer in the heap */
-        scanned++;
-        if (storeEntryLocked(e)) {
-            /*
-             * Entry is in use ... put it in a linked list to ignore it.
-             */
-            if (!EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-                /*
-                 * If this was a "SPECIAL" do not add it back into the heap.
-                 * It will always be "SPECIAL" and therefore never removed.
-                 */
-                debug(20, 4) ("storeDiskdDirMaintain: locked url %s\n",
-                    (e->mem_obj && e->mem_obj->url) ? e->mem_obj->url : storeKeyText(e->
-key));
-                linklistPush(&locked_entries, e);
-            }
-            locked++;
-            continue;
-        } else if (storeDiskdDirCheckExpired(SD, e)) {
-            /*
-             * Note: This will not check the reference age ifdef
-             * HEAP_REPLACEMENT, but it does some other useful
-             * checks...
-             */
-            expired++;
-            debug(20, 3) ("Released store object age %f size %d refs %d key %s\n",
-                age, e->swap_file_sz, e->refcount, storeKeyText(e->key));
-            min_age = age;
-            storeRelease(e);
-        } else {
-            /*
-             * Did not expire the object so we need to add it back
-             * into the heap!
-             */
-            debug(20, 5) ("storeMaintainSwapSpace: non-expired %s\n",
-                storeKeyText(e->key));
-            linklistPush(&locked_entries, e);
-            continue;
-        }
-        if (store_swap_size < store_swap_low)
-            break;
-        else if (expired >= max_remove)
-            break;
-        else if (scanned >= max_scan)
-            break;
-    }
-    /*
-     * Bump the heap age factor.
-     */
-    if (min_age > 0.0)
-        SD->repl.heap.heap->age = min_age;
-    /*
-     * Reinsert all bumped locked entries back into heap...
-     */
-    while ((e = linklistShift(&locked_entries)))
-        e->repl.node = heap_insert(SD->repl.heap.heap, e);
-#else
-    for (m = SD->repl.lru.list.tail; m; m = prev) {
-        prev = m->prev;
-        e = m->data;
-        scanned++;
-        if (storeEntryLocked(e)) {
-            /*
-             * If there is a locked entry at the tail of the LRU list,
-             * move it to the beginning to get it out of the way.
-             * Theoretically, we might have all locked objects at the
-             * tail, and then we'll never remove anything here and the
-             * LRU age will go to zero.
-             */
-            if (memInUse(MEM_STOREENTRY) > max_scan) {
-                dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-                dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-            }
-            locked++;
-
-        } else if (storeDiskdDirCheckExpired(SD, e)) {
-            expired++;
-            storeRelease(e);
-        }
-        if (expired >= max_remove)
-            break;
-        if (scanned >= max_scan)
-            break;
-    }
-#endif
-    debug(20, (expired ? 2 : 3)) ("storeMaintainSwapSpace: scanned %d/%d removed %d/%d l
-ocked %d f=%.03f\n",
-        scanned, max_scan, expired, max_remove, locked, f);
-    debug(20, 3) ("storeMaintainSwapSpace stats:\n");
-    debug(20, 3) ("  %6d objects\n", memInUse(MEM_STOREENTRY));
-    debug(20, 3) ("  %6d were scanned\n", scanned);
-    debug(20, 3) ("  %6d were locked\n", locked);
-    debug(20, 3) ("  %6d were expired\n", expired);
-    if (store_swap_size < Config.Swap.maxSize)
-        return;
-    if (squid_curtime - last_warn_time < 10)
-        return;
-    debug(20, 0) ("WARNING: Disk space over limit: %d KB > %d KB\n",
-        store_swap_size, Config.Swap.maxSize);
-    last_warn_time = squid_curtime;
+    walker = SD->repl->PurgeInit(SD->repl, max_scan);
+    while (1) {
+	/* XXX FixMe: This should use the cache_dir hig/low values, not the
+	 * global ones
+	 */
+	if (store_swap_size < store_swap_low)
+	    break;
+	if (removed >= max_remove)
+	    break;
+	e = walker->Next(walker);
+	if (!e)
+	    break;		/* no more objects */
+	removed++;
+	storeRelease(e);
+    }
+    walker->Done(walker);
+    debug(20, (removed ? 2 : 3)) ("storeDiskdDirMaintain: %s removed %d/%d f=%.03f max_scan=%d\n",
+	SD->path, removed, max_remove, f, max_scan);
 }
 
 /*
@@ -1566,29 +1460,29 @@
  * happily store anything as long as the LRU time isn't too small.
  */
 int
-storeDiskdDirCheckObj(SwapDir *SD, const StoreEntry *e)
+storeDiskdDirCheckObj(SwapDir * SD, const StoreEntry * e)
 {
     int loadav;
 
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
-#if !HEAP_REPLACEMENT
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
+#if OLD_UNUSED_CODE
     if (storeDiskdDirExpiredReferenceAge(SD) < 300) {
-        debug(20, 3) ("storeDiskdDirCheckObj: NO: LRU Age = %d\n",
-            storeDiskdDirExpiredReferenceAge(SD));
-        /* store_check_cachable_hist.no.lru_age_too_low++; */
-        return -1;
+	debug(20, 3) ("storeDiskdDirCheckObj: NO: LRU Age = %d\n",
+	    storeDiskdDirExpiredReferenceAge(SD));
+	/* store_check_cachable_hist.no.lru_age_too_low++; */
+	return -1;
     }
 #endif
 
     /* Check the queue length */
     if (diskdinfo->away >= diskdinfo->magic1)
-        return -1;
+	return -1;
 
     /* Calculate the storedir load relative to magic2 on a scale of 0 .. 1000 */
     if (diskdinfo->away == 0)
-        loadav = 0;
+	loadav = 0;
     else
-        loadav = diskdinfo->magic2 * 1000 / diskdinfo->away;
+	loadav = diskdinfo->magic2 * 1000 / diskdinfo->away;
     return loadav;
 }
 
@@ -1599,20 +1493,12 @@
  * maintain replacement information within the storage fs.
  */
 void
-storeDiskdDirRefObj(SwapDir *SD, StoreEntry *e)
+storeDiskdDirRefObj(SwapDir * SD, StoreEntry * e)
 {
     debug(1, 3) ("storeDiskdDirRefObj: referencing %p %d/%d\n", e, e->swap_dirn,
-      e->swap_filen);
-#if HEAP_REPLACEMENT
-    /* Nothing to do here */
-#else
-    /* Reference the object */
-    if (!EBIT_TEST(e->flags, RELEASE_REQUEST) &&
-        !EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-        dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-        dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-    }
-#endif
+	e->swap_filen);
+    if (SD->repl->Referenced)
+	SD->repl->Referenced(SD->repl, e, &e->repl);
 }
 
 /*
@@ -1621,14 +1507,12 @@
  * removed, to maintain replacement information within the storage fs.
  */
 void
-storeDiskdDirUnrefObj(SwapDir *SD, StoreEntry *e)
+storeDiskdDirUnrefObj(SwapDir * SD, StoreEntry * e)
 {
     debug(1, 3) ("storeDiskdDirUnrefObj: referencing %p %d/%d\n", e,
-      e->swap_dirn, e->swap_filen);
-#if HEAP_REPLACEMENT
-    if (e->repl.node)
-        heap_update(SD->repl.heap.heap, e->repl.node, e);
-#endif
+	e->swap_dirn, e->swap_filen);
+    if (SD->repl->Dereferenced)
+	SD->repl->Dereferenced(SD->repl, e, &e->repl);
 }
 
 /*
